diff -ruN ../nakedmudv3.2.1/src/Makefile src/Makefile
--- ../nakedmudv3.2.1/src/Makefile	2006-07-09 17:30:19.000000000 -0400
+++ src/Makefile	2006-12-24 22:27:44.000000000 -0500
@@ -43,7 +43,7 @@
 	   \
 	   races.c \
 	   \
-	   log.c auxiliary.c account_handler.c char_gen.c \
+	   log.c auxiliary.c \
 	   \
 	   world.c character.c room.c exit.c extra_descs.c object.c body.c \
 	   zone.c room_reset.c account.c \
diff -ruN ../nakedmudv3.2.1/src/SConstruct src/SConstruct
--- ../nakedmudv3.2.1/src/SConstruct	1969-12-31 19:00:00.000000000 -0500
+++ src/SConstruct	2006-12-24 23:35:27.000000000 -0500
@@ -0,0 +1,99 @@
+from distutils.sysconfig import get_config_var, get_python_inc
+from glob import glob
+from os import listdir
+from os.path import isdir, isfile, join
+from sys import platform, version_info
+from time import localtime, strftime
+
+# First, a couple of helper functions
+
+def probe_directory(directory):
+    """
+    Examine the contents of directory, and return a list that
+    satisfies the following properties:
+
+    1. If the directory does not contain a file called '.suppress',
+       all .c files in that directory.
+
+    2. If the directory contains a file called '.suppress', all .c
+       files in that directory that are not named by .suppress
+
+    3. If the directory contains a file called '.suppress', and the
+       file contains the line 'all', return the empty list.
+    """
+    try:
+        suppress = open(join(directory, '.suppress'), 'r')
+        suppress_files = [x.replace('\n', '') for x in suppress.readlines()]
+        suppress.close()
+    except IOError:
+        # Assume file not found
+        suppress_files = []
+    if 'all' in suppress_files:
+        return []
+    # Can't do this earlier because it mangles the 'all' line.
+    suppress_files = [join(directory, x) for x in suppress_files]
+    c_files = recursive_glob(directory, '*.c')
+    return [x for x in c_files if x not in suppress_files]
+
+def recursive_glob(directory, pattern):
+    """
+    Return a list of all files in directory that match the given pattern.
+    """
+    files = []
+    directories = [directory] + [x for x in listdir(directory) if isdir(x)]
+    while directories != []:
+        directories += [x for x in [join(directories[0], y) for y in listdir(directories[0])] if isdir(x)]
+        files += glob(join(directories[0], pattern))
+        directories = directories[1:]
+    return files
+
+# Initialise the build environment
+nakedmud = Environment()
+nakedmud.Append(CPPPATH=[get_python_inc()])
+# The following seems to break under Mac OSX, so we'll just filter it out. It still seems to work without it...
+if platform == 'darwin':
+    nakedmud.Append(LINKFLAGS=get_config_var('LINKFORSHARED').split())
+nakedmud.Append(LIBS=['python%d.%d' % version_info[0:2]])
+
+# The name of the binary file to build
+binary = 'NakedMud'
+
+# Required modules
+modules = ['char_vars', 'set_val', 'olc2', 'editor', 'items', 'scripts']
+
+# Optional modules
+modules += ['time', 'socials', 'alias', 'help']
+
+# Compiler flags
+nakedmud.Append(CCFLAGS=['-Wall', '-g', '-ggdb', '-O2'])
+
+# Required libraries
+nakedmud.Append(LIBS=['z', 'pthread', 'crypt'])
+
+# The big list of source files.
+nakedmud['NAKEDMUD_SOURCES'] = glob('*.c')
+
+# Export the nakedmud environment in case SConscripts need to modify it
+Export('nakedmud')
+
+# Work through the module dirs and append to the sources list
+for module in modules:
+    nakedmud['NAKEDMUD_SOURCES'] += probe_directory(module)
+    filename = join(module, 'SConscript')
+    if(isfile(filename)):
+        SConscript(filename)
+
+# Default target is build the program
+nakedmud.Default(nakedmud.Program(binary, nakedmud['NAKEDMUD_SOURCES']))
+
+# Backup stuff
+
+# Directories to include when making backups. Note that this is _NOT_ a Python list, it is passed
+# directly to tar.
+backup_dirs = 'src lib doc'
+# Name of the backup file
+backup_file = join('backup', '%s-%s.tar.gz' % (binary.lower(), strftime('%Y-%m-%d-%Hh%Mm', localtime())))
+# Rule for making backups
+nakedmud.Command(backup_file, [], ['cd .. ; tar -zcf %s %s' % (backup_file, backup_dirs)])
+# Alias so `scons backup` will make a backup
+nakedmud.Alias('backup', backup_file)
diff -ruN ../nakedmudv3.2.1/src/autorun.py src/autorun.py
--- ../nakedmudv3.2.1/src/autorun.py	2006-07-09 17:29:08.000000000 -0400
+++ src/autorun.py	2006-12-24 22:15:56.000000000 -0500
@@ -5,40 +5,48 @@
 #
 # This autorun script was designed to be used with NakedMud. It will 
 # automagically restart your MUD any time it crashes. If the MUD is manually
-# shut down, the autorun script will terminate. 
+# shut down, the autorun script will terminate. Accepts a port argument.
 #
 # Geoff Hollis
 # http://www.ualberta.ca/~hollis/nakedmud.html
 #
 ################################################################################
-
+import sys               # for sys.argv
 from time import sleep   # we delay before restarting
 from os   import system  # to start running the MUD
 
-# how long do we delay before a restart (seconds)
-restart_delay = 5
-
-# the path to the MUD binary
-path = './NakedMud'
-
-# the port we will be running the MUD under
-port = 4000
-
-# the command we execute to boot up the MUD
-cmd  = "%s %d" % (path, port)
-
-# now, while we have not exited without an error, run the MUD 
-# and reboot it every time we exit with an error (we crash)
-while True:
-    # run the MUD
-    status = system(cmd)
-
-    # exited normally
-    if status == 0:
-	break;
-    else:
-	# We should probably see if we can figure out what kind of
-	# error caused the crash here, and report it
-
-	# wait out our delay, then restart the MUD
-	sleep(restart_delay)
+def main(argv = sys.argv[1:]):
+    '''
+    handles the autorunning of the mud. Can accept 1 optional argument that
+    specifies the port number to run under
+    '''
+    restart_delay = 5     # how long do we delay before a restart (seconds)
+    path = './NakedMud'   # the path to the MUD binary
+    port = 4000           # the default port we will be running the MUD under
+
+    # parse out our port number if one was supplied
+    if len(argv) > 0:
+        port = int(argv[0])
+
+    # the command we execute to boot up the MUD
+    cmd  = "%s %d" % (path, port)
+
+    # now, while we have not exited without an error, run the MUD 
+    # and reboot it every time we exit with an error (we crash)
+    while True:
+        # run the MUD
+        status = system(cmd)
+
+        # exited normally
+        if status == 0:
+            break;
+        else:
+            # We should probably see if we can figure out what kind of
+            # error caused the crash here, and report it
+
+            # wait out our delay, then restart the MUD
+            sleep(restart_delay)
+
+# start us if we're run as a script
+if __name__ == "__main__":
+    sys.exit(main())
diff -ruN ../nakedmudv3.2.1/src/gameloop.c src/gameloop.c
--- ../nakedmudv3.2.1/src/gameloop.c	2006-07-09 17:29:08.000000000 -0400
+++ src/gameloop.c	2006-12-24 22:15:56.000000000 -0500
@@ -81,6 +81,7 @@
 PROPERTY_TABLE  *obj_table = NULL; // a table of objs by UID, for quick lookup
 PROPERTY_TABLE *room_table = NULL; // a table of rooms by UID, for quick lookup
 PROPERTY_TABLE *exit_table = NULL; // a table of exits by UID, for quick lookup
+PROPERTY_TABLE *sock_table = NULL; // a table of socks by UID, for quick lookup
 BUFFER           *greeting = NULL; // message seen when a socket connects
 BUFFER               *motd = NULL; // what characters see when they log on
 
@@ -146,10 +147,11 @@
   // For optimal speed, the table sizes should be roughly
   // 25% larger than the number of mobs/objs you intend to have
   // loaded into the game at any given time.
-  mob_table   = newPropertyTable(charGetUID, 3000);
-  obj_table   = newPropertyTable(objGetUID,  3000);
-  room_table  = newPropertyTable(roomGetUID, 3000);
-  exit_table  = newPropertyTable(exitGetUID, 9000);
+  mob_table   = newPropertyTable(charGetUID,  3000);
+  obj_table   = newPropertyTable(objGetUID,   3000);
+  room_table  = newPropertyTable(roomGetUID,  3000);
+  exit_table  = newPropertyTable(exitGetUID,  9000);
+  sock_table  = newPropertyTable(socketGetUID,1000);
 
   // make a new world
   gameworld = newWorld();
@@ -380,8 +382,13 @@
       int newConnection;
 
       socksize = sizeof(sock);
-      if ((newConnection = accept(control, (struct sockaddr*) &sock, &socksize)) >=0)
-        new_socket(newConnection);
+      if ((newConnection = accept(control, (struct sockaddr*) &sock, &socksize)) >=0) {
+        SOCKET_DATA *newsock = new_socket(newConnection);
+	if(newsock != NULL) {
+	  hookRun("receive_connection", hookBuildInfo("sk", newsock));
+	  socketBustPrompt(newsock);
+	}
+      }
     }
 
 
diff -ruN ../nakedmudv3.2.1/src/handler.c src/handler.c
--- ../nakedmudv3.2.1/src/handler.c	2006-07-09 17:29:08.000000000 -0400
+++ src/handler.c	2006-12-24 22:15:56.000000000 -0500
@@ -37,13 +37,40 @@
 //*****************************************************************************
 // obj/char from/to functions
 //*****************************************************************************
-void exit_to_game(EXIT_DATA *exit) {
+void exit_exist(EXIT_DATA *exit) {
   propertyTablePut(exit_table, exit);
 }
 
+bool exit_exists(EXIT_DATA *exit) {
+  return propertyTableIn(exit_table, exitGetUID(exit));
+}
+
+void exit_to_game(EXIT_DATA *exit) {
+  if(!exit_exists(exit))
+    exit_exist(exit);
+}
+
+void obj_exist(OBJ_DATA *obj) {
+  propertyTablePut(obj_table, obj);
+
+  // also add all contents
+  if(listSize(objGetContents(obj)) > 0) {
+    LIST_ITERATOR *cont_i = newListIterator(objGetContents(obj));
+    OBJ_DATA *cont = NULL;
+    ITERATE_LIST(cont, cont_i)
+      obj_exist(cont);
+    deleteListIterator(cont_i);
+  }
+}
+
+bool obj_exists(OBJ_DATA *obj) {
+  return propertyTableIn(obj_table, objGetUID(obj));
+}
+
 void obj_to_game(OBJ_DATA *obj) {
+  if(!obj_exists(obj))
+    obj_exist(obj);
   listPut(object_list, obj);
-  propertyTablePut(obj_table, obj);
 
   // execute all of our to_game hooks
   hookRun("obj_to_game", hookBuildInfo("obj", obj));
@@ -58,9 +85,45 @@
   }
 }
 
+void room_exist(ROOM_DATA *room) {
+  propertyTablePut(room_table, room);
+
+  // add contents
+  if(listSize(roomGetContents(room)) > 0) {
+    LIST_ITERATOR *cont_i = newListIterator(roomGetContents(room));
+    OBJ_DATA        *cont = NULL;
+    ITERATE_LIST(cont, cont_i)
+      obj_exist(cont);
+    deleteListIterator(cont_i);
+  }
+
+  // add its people
+  if(listSize(roomGetCharacters(room)) > 0) {
+    LIST_ITERATOR *ch_i = newListIterator(roomGetCharacters(room));
+    CHAR_DATA       *ch = NULL;
+    ITERATE_LIST(ch, ch_i)
+      char_exist(ch);
+    deleteListIterator(ch_i);
+  }
+
+  // add its exits
+  LIST       *ex_list = roomGetExitNames(room);
+  LIST_ITERATOR *ex_i = newListIterator(ex_list);
+  char           *dir = NULL;
+  ITERATE_LIST(dir, ex_i) {
+    exit_exist(roomGetExit(room, dir));
+  } deleteListIterator(ex_i);
+  deleteListWith(ex_list, free);
+}
+
+bool room_exists(ROOM_DATA *room) {
+  return propertyTableIn(room_table, roomGetUID(room));
+}
+
 void room_to_game(ROOM_DATA *room) {
+  if(!room_exists(room))
+    room_exist(room);
   listPut(room_list, room);
-  propertyTablePut(room_table, room);
 
   // execute all of our to_game hooks
   hookRun("room_to_game", hookBuildInfo("rm", room));
@@ -97,9 +160,38 @@
   deleteListWith(ex_list, free);
 }
 
+void char_exist(CHAR_DATA *ch) {
+  propertyTablePut(mob_table, ch);
+
+  // also add inventory
+  if(listSize(charGetInventory(ch)) > 0) {
+    LIST_ITERATOR *inv_i = newListIterator(charGetInventory(ch));
+    OBJ_DATA *obj = NULL;
+    ITERATE_LIST(obj, inv_i)
+      obj_exist(obj);
+    deleteListIterator(inv_i);
+  }
+
+  // and equipped items
+  LIST *eq = bodyGetAllEq(charGetBody(ch));
+  if(listSize(eq) > 0) {
+    LIST_ITERATOR *eq_i = newListIterator(eq);
+    OBJ_DATA *obj = NULL;
+    ITERATE_LIST(obj, eq_i)
+      obj_exist(obj);
+    deleteListIterator(eq_i);
+  }
+  deleteList(eq);
+}
+
+bool char_exists(CHAR_DATA *ch) {
+  return propertyTableIn(mob_table, charGetUID(ch));
+}
+
 void char_to_game(CHAR_DATA *ch) {
+  if(!char_exists(ch))
+    char_exist(ch);
   listPut(mobile_list, ch);
-  propertyTablePut(mob_table, ch);
 
   // execute all of our to_game hooks
   hookRun("char_to_game", hookBuildInfo("ch", ch));
@@ -133,9 +225,6 @@
   // go through all of our fromgame hooks
   hookRun("obj_from_game", hookBuildInfo("obj", obj));
 
-  listRemove(object_list, obj);
-  propertyTableRemove(obj_table, objGetUID(obj));
-
   // also remove everything that is contained within the object
   if(listSize(objGetContents(obj)) > 0) {
     LIST_ITERATOR *cont_i = newListIterator(objGetContents(obj));
@@ -144,15 +233,15 @@
       obj_from_game(cont);
     deleteListIterator(cont_i);
   }
+
+  listRemove(object_list, obj);
+  propertyTableRemove(obj_table, objGetUID(obj));
 }
 
 void room_from_game(ROOM_DATA *room) {
   // go through all of our fromgame hooks
   hookRun("room_from_game", hookBuildInfo("rm", room));
 
-  listRemove(room_list, room);
-  propertyTableRemove(room_table, roomGetUID(room));
-
   // also remove all the objects contained within the room
   if(listSize(roomGetContents(room)) > 0) {
     LIST_ITERATOR *cont_i = newListIterator(roomGetContents(room));
@@ -179,15 +268,15 @@
     exit_from_game(roomGetExit(room, dir));
   deleteListIterator(ex_i);
   deleteListWith(ex_list, free);
+
+  listRemove(room_list, room);
+  propertyTableRemove(room_table, roomGetUID(room));
 }
 
 void char_from_game(CHAR_DATA *ch) {
   // go through all of our fromgame hooks
   hookRun("char_from_game", hookBuildInfo("ch", ch));
 
-  listRemove(mobile_list, ch);
-  propertyTableRemove(mob_table, charGetUID(ch));
-
   // also remove inventory
   if(listSize(charGetInventory(ch)) > 0) {
     LIST_ITERATOR *inv_i = newListIterator(charGetInventory(ch));
@@ -207,6 +296,9 @@
     deleteListIterator(eq_i);
   }
   deleteList(eq);
+
+  listRemove(mobile_list, ch);
+  propertyTableRemove(mob_table, charGetUID(ch));
 }
 
 void obj_from_char(OBJ_DATA *obj) {
diff -ruN ../nakedmudv3.2.1/src/handler.h src/handler.h
--- ../nakedmudv3.2.1/src/handler.h	2006-07-09 17:29:08.000000000 -0400
+++ src/handler.h	2006-12-24 22:15:56.000000000 -0500
@@ -15,13 +15,25 @@
 // then its from_game function should be called, AND THEN it should be deleted.
 // When something needs to be put into the game, its to_game function should be
 // called AND THEN it should be added to the game (e.g. loading a character and
-// putting him into a room... call char_to_game first);
+// putting him into a room... call char_to_game first); exist functions are to
+// state that something is ready for interaction with but it is *not* ready to
+// be placed in the game yet. For instance, when a brand new character has been
+// made for character creation. Whenever something is put to_game, it is first
+// make to exist.
+void      char_exist        (CHAR_DATA *ch);
+bool      char_exists       (CHAR_DATA *ch);
 void      char_to_game      (CHAR_DATA *ch);
 void      char_from_game    (CHAR_DATA *ch);
+void      obj_exist         (OBJ_DATA  *obj);
+bool      obj_exists        (OBJ_DATA  *obj);
 void      obj_to_game       (OBJ_DATA  *obj);
 void      obj_from_game     (OBJ_DATA  *obj);
+void      room_exist        (ROOM_DATA *room);
+bool      room_exists       (ROOM_DATA *room);
 void      room_to_game      (ROOM_DATA *room);
 void      room_from_game    (ROOM_DATA *room);
+void      exit_exist        (EXIT_DATA *exit);
+bool      exit_exists       (EXIT_DATA *exit);
 void      exit_to_game      (EXIT_DATA *exit);
 void      exit_from_game    (EXIT_DATA *exit);
 
diff -ruN ../nakedmudv3.2.1/src/hooks.c src/hooks.c
--- ../nakedmudv3.2.1/src/hooks.c	2006-07-09 17:29:08.000000000 -0400
+++ src/hooks.c	2006-12-24 22:15:56.000000000 -0500
@@ -24,6 +24,7 @@
 #include "room.h"
 #include "exit.h"
 #include "account.h"
+#include "socket.h"
 #include "hooks.h"
 
 
@@ -114,6 +115,8 @@
       bprintf(info_buf, "rm.%d", roomGetUID(va_arg(vargs, ROOM_DATA *)));
     else if(!strcasecmp(token, "ex") || !strcasecmp(token, "exit"))
       bprintf(info_buf, "ex.%d", exitGetUID(va_arg(vargs, EXIT_DATA *)));
+    else if(!strcasecmp(token, "sk") || !strcasecmp(token, "sock"))
+      bprintf(info_buf, "sk.%d", socketGetUID(va_arg(vargs, SOCKET_DATA *)));
     else if(!strcasecmp(token, "str"))
       bprintf(info_buf, "%c%s%c", HOOK_STR_MARKER, va_arg(vargs, char *), HOOK_STR_MARKER);
     else if(!strcasecmp(token, "int"))
@@ -209,6 +212,14 @@
       sscanf(token, "exit.%d", &id);
       *va_arg(vargs, EXIT_DATA **) = propertyTableGet(exit_table, id);
     }
+    else if(startswith(token, "sk")) {
+      sscanf(token, "sk.%d", &id);
+      *va_arg(vargs, SOCKET_DATA **) = propertyTableGet(sock_table, id);
+    }
+    else if(startswith(token, "sock")) {
+      sscanf(token, "sk.%d", &id);
+      *va_arg(vargs, SOCKET_DATA **) = propertyTableGet(sock_table, id);
+    }
     else if(*token == HOOK_STR_MARKER) {
       char *str = strdup(token + 1);
       str[strlen(str)-1] = '\0';
diff -ruN ../nakedmudv3.2.1/src/inform.c src/inform.c
--- ../nakedmudv3.2.1/src/inform.c	2006-07-09 17:29:08.000000000 -0400
+++ src/inform.c	2006-12-24 22:15:56.000000000 -0500
@@ -311,7 +311,8 @@
     LIST_ITERATOR *list_i = newListIterator(mobile_list);
     CHAR_DATA *ch = NULL;
     ITERATE_LIST(ch, list_i)
-      if(roomGetTerrain(charGetRoom(ch)) != TERRAIN_INDOORS &&
+      if(charGetRoom(ch) != NULL &&
+	 roomGetTerrain(charGetRoom(ch)) != TERRAIN_INDOORS &&
 	 roomGetTerrain(charGetRoom(ch)) != TERRAIN_CAVERN)
 	text_to_char(ch, buf);
     deleteListIterator(list_i);
@@ -383,8 +384,7 @@
     if(!charGetSocket(ch) || !bitIsSet(charGetUserGroups(ch), groups))
       continue;
     text_to_char(ch, buf);
-  }
-  deleteListIterator(ch_i);
+  } deleteListIterator(ch_i);
 }
 
 
@@ -640,7 +640,7 @@
     return;
 
   // what's our scope?
-  if(IS_SET(range, TO_VICT) &&
+  if(IS_SET(range, TO_VICT) && vict &&
      (!hide_nosee ||
       // make sure the vict can the character, or the
       // object if there is no character
@@ -649,7 +649,7 @@
     send_message(vict, mssg, ch, vict, obj, vobj);
 
   // characters can always see themselves. No need to do checks here
-  if(IS_SET(range, TO_CHAR))
+  if(IS_SET(range, TO_CHAR) && ch)
     send_message(ch, mssg, ch, vict, obj, vobj);
 
   LIST *recipients = NULL;
@@ -669,6 +669,9 @@
       // if we wanted to send to ch or vict, we would have already...
       if(rec == vict || rec == ch)
 	continue;
+      // skip by people who are in the game but not in the world yet
+      if(charGetRoom(rec) == NULL)
+	continue;
       if(rec == ch ||
 	 (!hide_nosee ||
 	  // make sure the vict can see the character, or the
diff -ruN ../nakedmudv3.2.1/src/items/worn.c src/items/worn.c
--- ../nakedmudv3.2.1/src/items/worn.c	2006-07-09 17:29:07.000000000 -0400
+++ src/items/worn.c	2006-12-25 19:32:04.000000000 -0500
@@ -43,6 +43,7 @@
 //*****************************************************************************
 #include "../scripts/scripts.h"
 #include "../scripts/pyobj.h"
+#include "../scripts/pymudsys.h"
 
 
 
@@ -222,12 +223,18 @@
 }
 
 void worn_from_proto(WORN_DATA *worn, BUFFER *buf) {
-  char worn_type[SMALL_BUFFER];
-  sscanf(bufferString(buf), "me.worn_type = \"%s", worn_type);
-  worn_type[next_letter_in(worn_type, '\"')] = '\0'; // kill closing "
-  if(hashIn(worn_table, worn_type)) {
+  const char *code = bufferString(buf);
+  char        line[SMALL_BUFFER];
+  char       *lptr = line;
+
+  // parse out our worn type
+  code = strcpyto(lptr, code, '\n'); 
+  while(*lptr != '\"') lptr++;
+  lptr++; // kill the leading "
+  lptr[next_letter_in(lptr, '\"')] = '\0'; // kill closing "
+  if(hashIn(worn_table, lptr)) {
     if(worn->type) free(worn->type);
-    worn->type = strdup(worn_type);
+    worn->type = strdup(lptr);
   }
 }
 
@@ -280,6 +287,20 @@
   return 0;
 }
 
+PyObject *PyMudSys_AddWornType(PyObject *self, PyObject *args) {
+  char *type = NULL;
+  char  *pos = NULL;
+
+  if(!PyArg_ParseTuple(args, "ss", &type, &pos)) {
+    PyErr_Format(PyExc_TypeError, "add_worn_type requires worn type "
+		 "and position list.");
+    return NULL;
+  }
+
+  worn_add_type(type, pos);
+  return Py_BuildValue("i", 1);
+}
+
 
 
 //*****************************************************************************
@@ -314,8 +335,14 @@
   // add our new python get/setters
   PyObj_addGetSetter("worn_type", PyObj_getworntype, PyObj_setworntype,
 		     "The type of clothing this wearable item is.");
+  PyMudSys_addMethod("add_worn_type", PyMudSys_AddWornType, METH_VARARGS,
+		     "Adds a new worn type to the game.");
   
   // add in our basic worn types
+  //
+  // As of v3.3, worn types can now be added via Python as well as C. People are
+  // encouraged to do so, outside of this module. These are left for historical
+  // purpposes and backwards compatibility with previous version equipment.
   worn_add_type("shirt",                        "torso");
   worn_add_type("gloves",       "left hand, right hand");
   worn_add_type("left glove",               "left hand");
diff -ruN ../nakedmudv3.2.1/src/mud.h src/mud.h
--- ../nakedmudv3.2.1/src/mud.h	2006-07-09 17:29:08.000000000 -0400
+++ src/mud.h	2006-12-24 22:15:56.000000000 -0500
@@ -208,6 +208,7 @@
 extern  PROPERTY_TABLE     *obj_table; // a mapping between uid and obj
 extern  PROPERTY_TABLE    *room_table; // a mapping between uid and room
 extern  PROPERTY_TABLE    *exit_table; // a mapping between uid and exit
+extern  PROPERTY_TABLE    *sock_table; // a mapping between uid and socket
 
 extern  bool                shut_down; // used for shutdown
 extern  int                   mudport; // What port are we running on?
@@ -240,12 +241,6 @@
 
 /* interpret.c */
 void  handle_cmd_input        ( SOCKET_DATA *dsock, char *arg );
-
-/* account_hanlder.c */
-void account_handle_menu      ( SOCKET_DATA *sock, char *arg);
-void account_menu             ( SOCKET_DATA *sock);
-
-
 void  do_cmd                  ( CHAR_DATA *ch, char *arg, bool aliases_ok);
 
 /* io.c */
diff -ruN ../nakedmudv3.2.1/src/prototype.c src/prototype.c
--- ../nakedmudv3.2.1/src/prototype.c	2006-07-09 17:29:09.000000000 -0400
+++ src/prototype.c	2006-12-24 22:15:56.000000000 -0500
@@ -214,11 +214,14 @@
   if(protoIsAbstract(proto))
     return NULL;
   CHAR_DATA *ch = newMobile();
-  char_to_game(ch);
-  if(!protoRun(proto, "mproto", charGetPyForm, charAddPrototype, charSetClass, ch)){
+  char_exist(ch);
+  if(protoRun(proto, "mproto", charGetPyForm, charAddPrototype, charSetClass, ch))
+    char_to_game(ch);
+  else {
     extract_mobile(ch);
     ch = NULL;
   }
+
   return ch;
 }
 
@@ -226,11 +229,14 @@
   if(protoIsAbstract(proto))
     return NULL;
   OBJ_DATA *obj = newObj();
-  obj_to_game(obj);
-  if(!protoRun(proto, "oproto", newPyObj, objAddPrototype, objSetClass, obj)) {
+  obj_exist(obj);
+  if(protoRun(proto, "oproto", newPyObj, objAddPrototype, objSetClass, obj))
+    obj_to_game(obj);
+  else {
     extract_obj(obj);
     obj = NULL;
   }
+
   return obj;
 }
 
@@ -238,10 +244,13 @@
   if(protoIsAbstract(proto))
     return NULL;
   ROOM_DATA *room = newRoom();
-  room_to_game(room);
-  if(!protoRun(proto, "rproto", newPyRoom, roomAddPrototype,roomSetClass,room)){
+  room_exist(room);
+  if(protoRun(proto, "rproto", newPyRoom, roomAddPrototype,roomSetClass,room))
+    room_to_game(room);
+  else {
     extract_room(room);
     room = NULL;
   }
+
   return room;
 }
diff -ruN ../nakedmudv3.2.1/src/room.c src/room.c
--- ../nakedmudv3.2.1/src/room.c	2006-07-09 17:29:09.000000000 -0400
+++ src/room.c	2006-12-24 22:15:56.000000000 -0500
@@ -216,7 +216,8 @@
   // as well, and remove all of the old exits from game. Its sort of hackish to
   // do it here since the room datastructure should have no concept of in/out
   // of game, but there's really nowhere else to put this...
-  bool room_in_game = propertyTableIn(room_table, to->uid);
+  bool does_room_exist = room_exists(to);
+  bool room_in_game    = listIn(room_list, to);
 
   // first, delete all of our old exits
   HASH_ITERATOR *ex_i = newHashIterator(to->exits);
@@ -224,7 +225,7 @@
   EXIT_DATA       *ex = NULL;
   ITERATE_HASH(dir, ex, ex_i) {
     hashRemove(to->exits, dir);
-    if(room_in_game) exit_from_game(ex);
+    if(does_room_exist) exit_from_game(ex);
     deleteExit(ex);
   } deleteHashIterator(ex_i);
 
@@ -232,7 +233,8 @@
   ex_i = newHashIterator(from->exits);
   ITERATE_HASH(dir, ex, ex_i) {
     roomSetExit(to, dir, exitCopy(ex));
-    if(room_in_game) exit_to_game(roomGetExit(to, dir));
+    if(does_room_exist) exit_exist(ex);
+    if(room_in_game)    exit_to_game(roomGetExit(to, dir));
   } deleteHashIterator(ex_i);
 
   // delete all of our old commands
diff -ruN ../nakedmudv3.2.1/src/save.c src/save.c
--- ../nakedmudv3.2.1/src/save.c	2006-07-09 17:29:09.000000000 -0400
+++ src/save.c	2006-12-24 22:15:56.000000000 -0500
@@ -309,13 +309,32 @@
   }
 }
 
+
+void reference_account(ACCOUNT_DATA *account) {
+  SAVE_REF_DATA *ref_data = hashGet(account_table, accountGetName(account));
+  if(ref_data == NULL)
+    log_string("ERROR: Tried referencing account '%s' that is not loaded!",
+	       accountGetName(account));
+  else
+    ref_data->refcnt++;
+}
+
+void reference_player(CHAR_DATA *ch) {
+  SAVE_REF_DATA *ref_data = hashGet(player_table, charGetName(ch));
+  if(ref_data == NULL)
+    log_string("ERROR: Tried referencing player '%s' that is not loaded!",
+	       charGetName(ch));
+  else
+    ref_data->refcnt++;
+}
+
 void register_account(ACCOUNT_DATA *account) {
   if(account_exists(accountGetName(account)))
     log_string("ERROR: Tried to register already-registered account, '%s'",
 	       accountGetName(account));
   else {
-    save_account(account);
     hashPut(account_table, accountGetName(account), newSaveRefData(account));
+    save_account(account);
   }
 }
 
@@ -324,8 +343,8 @@
     log_string("ERROR: Tried to register already-registered player, '%s'",
 	       charGetName(ch));
   else {
-    save_player(ch);
     hashPut(player_table, charGetName(ch), newSaveRefData(ch));
+    save_player(ch);
   }
 }
 
diff -ruN ../nakedmudv3.2.1/src/save.h src/save.h
--- ../nakedmudv3.2.1/src/save.h	2006-07-09 17:29:09.000000000 -0400
+++ src/save.h	2006-12-24 22:15:56.000000000 -0500
@@ -33,6 +33,8 @@
 
 void  unreference_account(ACCOUNT_DATA *account);
 void   unreference_player(CHAR_DATA    *ch);
+void    reference_account(ACCOUNT_DATA *account);
+void     reference_player(CHAR_DATA    *ch);
 
 void     register_account(ACCOUNT_DATA *account);
 void      register_player(CHAR_DATA    *ch);
diff -ruN ../nakedmudv3.2.1/src/scripts/module.mk src/scripts/module.mk
--- ../nakedmudv3.2.1/src/scripts/module.mk	2006-07-09 17:30:27.000000000 -0400
+++ src/scripts/module.mk	2006-12-24 22:48:04.000000000 -0500
@@ -105,6 +105,8 @@
 	scripts/pyhooks.c       \
 	scripts/pyroom.c        \
 	scripts/pyexit.c        \
+	scripts/pyaccount.c     \
+	scripts/pysocket.c      \
 	scripts/script_editor.c \
 	scripts/pyplugs.c       \
 	scripts/pyevent.c       \
